﻿using System;
using System.Collections.Generic;
using System.Windows.Forms;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace BryanKellyCapstone2017
{
    class AITestFunctions
    {
        public event EventHandler errorTryingToMoveRobot;
        public event EventHandler robotReachedDestination;
        //System.Threading.Thread.Sleep(1000);
        private FloorMap floorMap;
        private List<string[]> stateArrayRobot;
        private int depthOfSearch;

        private const string EMPTY = "0";
        private const string WALL = "1";
        private const string ROBOT = "2";
        private const string TARGET = "3";
        private const string GOAL = "G";
        private const string VISITED = "V";

       
        public void depthFirstSearchRobot(FloorMap tempFloorMap,int goalRow,int goalColumn)
        {
            floorMap = tempFloorMap;
            depthOfSearch = 0;
            stateArrayRobot = new List<string[]>();
            for (int i = 0; i < floorMap.NumRows; i++)
            {
                stateArrayRobot.Add(floorMap.FloorLayout[i]);
            }
            stateArrayRobot[goalRow][goalColumn] = GOAL;
            if (progressDFSRobot())
            {
                eventRobotReacheDestination();
            }
            else
            {
                eventErrorTryingToRemoveRobot();
            }
            

        }
        public bool progressDFSRobot()
        {
            depthOfSearch++;
            if (depthOfSearch > 100)
            {
                return false;
            }
            System.Threading.Thread.Sleep(50);
            stateArrayRobot[floorMap.RobotRow][floorMap.RobotColumn] = VISITED;
            if (stateArrayRobot[floorMap.RobotRow][floorMap.RobotColumn] == GOAL)
                return true;
            else
            {
                if(floorMap.isValidLocation(floorMap.RobotRow -1,floorMap.RobotColumn) && stateArrayRobot[floorMap.RobotRow-1][floorMap.RobotColumn] != VISITED)
                {
                    if (floorMap.moveRobotNorth(false)) {
                        if (progressDFSRobot())
                            return true;
                        else
                            floorMap.moveRobotSouth();
                    }
                }
                
                if(floorMap.isValidLocation(floorMap.RobotRow, floorMap.RobotColumn-1) && stateArrayRobot[floorMap.RobotRow][floorMap.RobotColumn - 1] != VISITED)
                {
                    if (floorMap.moveRobotWest(false))
                    {
                        if (progressDFSRobot())
                            return true;
                        else
                            floorMap.moveRobotEast();
                    }
                }
                if (floorMap.isValidLocation(floorMap.RobotRow+1, floorMap.RobotColumn) && stateArrayRobot[floorMap.RobotRow + 1][floorMap.RobotColumn] != VISITED)
                {
                    if (floorMap.moveRobotSouth(false))
                    {
                        if (progressDFSRobot())
                            return true;
                        else
                            floorMap.moveRobotNorth();
                    }
                }
                if (floorMap.isValidLocation(floorMap.RobotRow, floorMap.RobotColumn+1) && stateArrayRobot[floorMap.RobotRow][floorMap.RobotColumn +1] != VISITED)
                {
                    if(floorMap.moveRobotEast(false))
                    {
                        if (progressDFSRobot())
                            return true;
                        else
                            floorMap.moveRobotWest();
                    }
                }
                return false;
            }
        }

        public void moveRobotToGoal(FloorMap tempFloorMap,int goalRow, int goalColumn)
        {
            
            floorMap = tempFloorMap;
            int row,column;
            while (!isRobotAtGoal(goalRow,goalColumn))
            {
                System.Threading.Thread.Sleep(50);
                row = floorMap.RobotRow;
                column = floorMap.RobotColumn;
                if (row < 0 || column < 0)
                    return;

                if (goalRow == row)
                {   //already at goal row, now move closer to goal column
                    if (!moveRobotToCloserColumn(goalColumn))
                    {
                        eventErrorTryingToRemoveRobot();
                        return;
                    }
                }
                else if(goalColumn == column)
                {   //already at goal column, now move closer to goal row
                    if (!moveRobotToCloserRow(goalRow))
                    {
                        eventErrorTryingToRemoveRobot();
                        return;
                    }
                }
                else
                {   //not at either goal row or goal column, find which is closer
                    if (Math.Abs(goalRow - floorMap.RobotRow) < Math.Abs(goalColumn - floorMap.RobotColumn))
                    {   //closer to goal row than goal column
                        if (!moveRobotToCloserRow(goalRow))
                        { //If it can't move up or down try left or right
                            if (!moveRobotToCloserColumn(goalColumn))
                            {
                                eventErrorTryingToRemoveRobot();
                                return;
                            }
                        }
                    }
                    else
                    {
                        if (!moveRobotToCloserColumn(goalColumn))
                        {   //if it can't move left or right try up or down
                            if (!moveRobotToCloserRow(goalRow))
                            {
                                eventErrorTryingToRemoveRobot();
                                return;
                            }
                                    
                        }
                    }
                }
            }
            eventRobotReacheDestination();
        }
        private void eventErrorTryingToRemoveRobot()
        {
            if (this.errorTryingToMoveRobot != null)
                this.errorTryingToMoveRobot(this, EventArgs.Empty);
        }
        private void eventRobotReacheDestination()
        {
            if (this.robotReachedDestination != null)
                this.robotReachedDestination(this, EventArgs.Empty);
        }
        private bool moveRobotToCloserRow(int goalRow)
        {
            if ((goalRow - floorMap.RobotRow) > 0)
            {
                if (floorMap.moveRobotSouth())
                    return true;
                else
                    return false;
            }
            else
            {
                if (floorMap.moveRobotNorth())
                    return true;
                else
                    return false;
            }
                
        }
        private bool moveRobotToCloserColumn(int goalColumn)
        {
            if ((goalColumn - floorMap.RobotColumn) > 0)
            {
                if (floorMap.moveRobotEast())
                    return true;
                else
                    return false;
            }
            else
            {
                if (floorMap.moveRobotWest())
                    return true;
                else
                    return false;
            }
        }
        private bool isRobotAtGoal(int goalRow, int goalColumn)
        {
            return (floorMap.RobotRow == goalRow && floorMap.RobotColumn == goalColumn);
        }
    }
}
